Subject: bug#61098: 29.0.60; Confusing behavior of show-paren-mode

From: Eli Zaretskii <[email-masked]>
Date: Sat, 28 Jan 2023 14:20:05 +0200

> Date: Fri, 27 Jan 2023 17:03:14 +0100
> From:  Rah Guzar via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> 
> Dear Emacs maintainers,
>    After updating to Emacs 29, I saw in NEWS that show-paren-mode
>    is no longer enabled in special-mode buffers. I think that is a
>    welcome change. However in some cases (like reading the elisp
>    manual) it is helpful to have it enabled. My impression after
>    reading the NEWS entry, the manual entry for show-paren-mode
>    and documentation for show-paren-local-mode was that I should
>    be able to able to turn on show-paren-mode buffer locally by
> 
>             M-x show-paren-local-mode RET
> 
>     However this doesn't work and after much confusion I realized
>     that calling show-paren-local-mode has effect only if I customize
>     show-paren-predicate. My (incorrect) impression after reading
>     the documentation was that show-paren-predicate determines only
>     whether show-paren-mode is enabled in a buffer by default but
>     doesn't prohibit the possibility of turning it off.

Your impression was correct: there should be no need to customize
show-paren-predicate to turn on show-paren-local-mode in a buffer that
is under a descendant of special-mode.  The patch below fixes the bug
and allows you to do what you want without messing with
show-paren-predicate.

However, there's one glitch: after applying the patch, when you invoke

   M-x show-paren-local-mode RET

in a special-mode buffer, it says the mode is _disabled_, and indeed
disables the mode.  You need to enable it by invoking the same command
again.

I'm not sure I understand the reason, but it is probably related to
the fact that we use the same show-paren-mode variable for the
localized mode, and the default value of that variable is t.

Stefan, can you help here? how do we make show-paren-local-mode be
enabled when the user explicitly invokes it?

Here's the patch I promised above:

diff --git a/lisp/paren.el b/lisp/paren.el
index b2a7962..de14de2 100644
--- a/lisp/paren.el
+++ b/lisp/paren.el
@@ -167,8 +167,11 @@ show-paren-local-mode
     (unless show-paren-mode
       (show-paren--delete-overlays))
     (kill-local-variable 'show-paren-mode))
-   ((not (default-value 'show-paren-mode))
-    ;; Locally enabled, but globally disabled.
+   ((or
+     ;; Locally enabled, but globally disabled.
+     (not (default-value 'show-paren-mode))
+     ;; Disabled by 'show-paren-predicate'.
+     (not (buffer-match-p show-paren-predicate (current-buffer))))
     (show-paren-mode 1)                ; Setup the timer.
     (setq-default show-paren-mode nil) ; But keep it globally disabled.
     )